// This file is generated by kconfig_compiler_kf6 from globalconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef GLOBALCONFIG_H
#define GLOBALCONFIG_H

#include "globalconfigskeleton.h"

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class GlobalConfig : public GlobalConfigSkeleton
{
  Q_OBJECT
  public:

    GlobalConfig( QObject *parent = nullptr );
    ~GlobalConfig() override;

    /**
      Set Percent step for changing volume.
    */
    void setVolumeStep( int v )
    {
      if (v != mVolumeStep && !isVolumeStepImmutable()) {
        mVolumeStep = v;
        Q_EMIT VolumeStepChanged();
      }
    }

    Q_PROPERTY(int volumeStep READ volumeStep WRITE setVolumeStep NOTIFY VolumeStepChanged)
    Q_PROPERTY(bool isVolumeStepImmutable READ isVolumeStepImmutable CONSTANT)
    /**
      Get Percent step for changing volume.
    */
    int volumeStep() const
    {
      return mVolumeStep;
    }

    /**
      Is Percent step for changing volume. Immutable
    */
    bool isVolumeStepImmutable() const
    {
      return isImmutable( QStringLiteral( "VolumeStep" ) );
    }

    /**
      Set Allow raising volume over 100%.
    */
    void setRaiseMaximumVolume( bool v )
    {
      if (v != mRaiseMaximumVolume && !isRaiseMaximumVolumeImmutable()) {
        mRaiseMaximumVolume = v;
        Q_EMIT RaiseMaximumVolumeChanged();
      }
    }

    Q_PROPERTY(bool raiseMaximumVolume READ raiseMaximumVolume WRITE setRaiseMaximumVolume NOTIFY RaiseMaximumVolumeChanged)
    Q_PROPERTY(bool isRaiseMaximumVolumeImmutable READ isRaiseMaximumVolumeImmutable CONSTANT)
    /**
      Get Allow raising volume over 100%.
    */
    bool raiseMaximumVolume() const
    {
      return mRaiseMaximumVolume;
    }

    /**
      Is Allow raising volume over 100%. Immutable
    */
    bool isRaiseMaximumVolumeImmutable() const
    {
      return isImmutable( QStringLiteral( "RaiseMaximumVolume" ) );
    }

    /**
      Set Play audio feedback when changing volume.
    */
    void setAudioFeedback( bool v )
    {
      if (v != mAudioFeedback && !isAudioFeedbackImmutable()) {
        mAudioFeedback = v;
        Q_EMIT AudioFeedbackChanged();
      }
    }

    Q_PROPERTY(bool audioFeedback READ audioFeedback WRITE setAudioFeedback NOTIFY AudioFeedbackChanged)
    Q_PROPERTY(bool isAudioFeedbackImmutable READ isAudioFeedbackImmutable CONSTANT)
    /**
      Get Play audio feedback when changing volume.
    */
    bool audioFeedback() const
    {
      return mAudioFeedback;
    }

    /**
      Is Play audio feedback when changing volume. Immutable
    */
    bool isAudioFeedbackImmutable() const
    {
      return isImmutable( QStringLiteral( "AudioFeedback" ) );
    }

    /**
      Set Show OSD when changing volume.
    */
    void setVolumeOsd( bool v )
    {
      if (v != mVolumeOsd && !isVolumeOsdImmutable()) {
        mVolumeOsd = v;
        Q_EMIT VolumeOsdChanged();
      }
    }

    Q_PROPERTY(bool volumeOsd READ volumeOsd WRITE setVolumeOsd NOTIFY VolumeOsdChanged)
    Q_PROPERTY(bool isVolumeOsdImmutable READ isVolumeOsdImmutable CONSTANT)
    /**
      Get Show OSD when changing volume.
    */
    bool volumeOsd() const
    {
      return mVolumeOsd;
    }

    /**
      Is Show OSD when changing volume. Immutable
    */
    bool isVolumeOsdImmutable() const
    {
      return isImmutable( QStringLiteral( "VolumeOsd" ) );
    }

    /**
      Set Show OSD when changing microphone sensitivity.
    */
    void setMicrophoneSensitivityOsd( bool v )
    {
      if (v != mMicrophoneSensitivityOsd && !isMicrophoneSensitivityOsdImmutable()) {
        mMicrophoneSensitivityOsd = v;
        Q_EMIT MicrophoneSensitivityOsdChanged();
      }
    }

    Q_PROPERTY(bool microphoneSensitivityOsd READ microphoneSensitivityOsd WRITE setMicrophoneSensitivityOsd NOTIFY MicrophoneSensitivityOsdChanged)
    Q_PROPERTY(bool isMicrophoneSensitivityOsdImmutable READ isMicrophoneSensitivityOsdImmutable CONSTANT)
    /**
      Get Show OSD when changing microphone sensitivity.
    */
    bool microphoneSensitivityOsd() const
    {
      return mMicrophoneSensitivityOsd;
    }

    /**
      Is Show OSD when changing microphone sensitivity. Immutable
    */
    bool isMicrophoneSensitivityOsdImmutable() const
    {
      return isImmutable( QStringLiteral( "MicrophoneSensitivityOsd" ) );
    }

    /**
      Set Show OSD when muting/unmuting.
    */
    void setMuteOsd( bool v )
    {
      if (v != mMuteOsd && !isMuteOsdImmutable()) {
        mMuteOsd = v;
        Q_EMIT MuteOsdChanged();
      }
    }

    Q_PROPERTY(bool muteOsd READ muteOsd WRITE setMuteOsd NOTIFY MuteOsdChanged)
    Q_PROPERTY(bool isMuteOsdImmutable READ isMuteOsdImmutable CONSTANT)
    /**
      Get Show OSD when muting/unmuting.
    */
    bool muteOsd() const
    {
      return mMuteOsd;
    }

    /**
      Is Show OSD when muting/unmuting. Immutable
    */
    bool isMuteOsdImmutable() const
    {
      return isImmutable( QStringLiteral( "MuteOsd" ) );
    }

    /**
      Set Show OSD when changing default output device.
    */
    void setDefaultOutputDeviceOsd( bool v )
    {
      if (v != mDefaultOutputDeviceOsd && !isDefaultOutputDeviceOsdImmutable()) {
        mDefaultOutputDeviceOsd = v;
        Q_EMIT DefaultOutputDeviceOsdChanged();
      }
    }

    Q_PROPERTY(bool defaultOutputDeviceOsd READ defaultOutputDeviceOsd WRITE setDefaultOutputDeviceOsd NOTIFY DefaultOutputDeviceOsdChanged)
    Q_PROPERTY(bool isDefaultOutputDeviceOsdImmutable READ isDefaultOutputDeviceOsdImmutable CONSTANT)
    /**
      Get Show OSD when changing default output device.
    */
    bool defaultOutputDeviceOsd() const
    {
      return mDefaultOutputDeviceOsd;
    }

    /**
      Is Show OSD when changing default output device. Immutable
    */
    bool isDefaultOutputDeviceOsdImmutable() const
    {
      return isImmutable( QStringLiteral( "DefaultOutputDeviceOsd" ) );
    }

    /**
      Set Mute all audio.
    */
    void setGlobalMute( bool v )
    {
      if (v != mGlobalMute && !isGlobalMuteImmutable()) {
        mGlobalMute = v;
        Q_EMIT GlobalMuteChanged();
      }
    }

    Q_PROPERTY(bool globalMute READ globalMute WRITE setGlobalMute NOTIFY GlobalMuteChanged)
    Q_PROPERTY(bool isGlobalMuteImmutable READ isGlobalMuteImmutable CONSTANT)
    /**
      Get Mute all audio.
    */
    bool globalMute() const
    {
      return mGlobalMute;
    }

    /**
      Is Mute all audio. Immutable
    */
    bool isGlobalMuteImmutable() const
    {
      return isImmutable( QStringLiteral( "GlobalMute" ) );
    }

    /**
      Set Devices that were not muted with global mute, and will remain muted afterwards.
    */
    void setGlobalMuteDevices( const QStringList & v )
    {
      if (v != mGlobalMuteDevices && !isGlobalMuteDevicesImmutable()) {
        mGlobalMuteDevices = v;
        Q_EMIT GlobalMuteDevicesChanged();
      }
    }

    Q_PROPERTY(QStringList globalMuteDevices READ globalMuteDevices WRITE setGlobalMuteDevices NOTIFY GlobalMuteDevicesChanged)
    Q_PROPERTY(bool isGlobalMuteDevicesImmutable READ isGlobalMuteDevicesImmutable CONSTANT)
    /**
      Get Devices that were not muted with global mute, and will remain muted afterwards.
    */
    QStringList globalMuteDevices() const
    {
      return mGlobalMuteDevices;
    }

    /**
      Is Devices that were not muted with global mute, and will remain muted afterwards. Immutable
    */
    bool isGlobalMuteDevicesImmutable() const
    {
      return isImmutable( QStringLiteral( "GlobalMuteDevices" ) );
    }


    enum {
      signalVolumeStepChanged = 1,
      signalRaiseMaximumVolumeChanged = 2,
      signalAudioFeedbackChanged = 3,
      signalVolumeOsdChanged = 4,
      signalMicrophoneSensitivityOsdChanged = 5,
      signalMuteOsdChanged = 6,
      signalDefaultOutputDeviceOsdChanged = 7,
      signalGlobalMuteChanged = 8,
      signalGlobalMuteDevicesChanged = 9
    };

  Q_SIGNALS:
    void VolumeStepChanged();

    void RaiseMaximumVolumeChanged();

    void AudioFeedbackChanged();

    void VolumeOsdChanged();

    void MicrophoneSensitivityOsdChanged();

    void MuteOsdChanged();

    void DefaultOutputDeviceOsdChanged();

    void GlobalMuteChanged();

    void GlobalMuteDevicesChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:

    // General
    int mVolumeStep;
    bool mRaiseMaximumVolume;
    bool mAudioFeedback;
    bool mVolumeOsd;
    bool mMicrophoneSensitivityOsd;
    bool mMuteOsd;
    bool mDefaultOutputDeviceOsd;
    bool mGlobalMute;
    QStringList mGlobalMuteDevices;

  private:
};

#endif

